LIBRARY ieee;
USE ieee.std_logic_1164.all;
-- USE ieee.std_logic_unsigned.all;

entity part1b is
	port
	(
		SW	 : in std_logic_vector(1 downto 0);
		Key : in std_logic_vector(0 downto 0);
		Hex0 : out std_logic_vector(0 to 6);
		Hex1 : out std_logic_vector(0 to 6);
      LEDR : out std_logic_vector(9 downto 0)		
	);
end;


architecture behav of part1b is
   signal count : std_logic_vector(7 downto 0);
	signal En, Clear, Clk : std_logic;
begin

   LEDR(1 downto 0) <= SW;
	LEDR(2) <= KEY(0);
	LEDR(9 downto 3) <= (others=>'0');
	En <= SW(1);
	Clear <= SW(0);
	Clk <= KEY(0);

   C8B: entity work.EightBitCounter(behav)
	port map (Enable=>En, Clear=>Clear, Clock=>Clk, Q=>count);
	
   H1: entity work.DisplayDigit(behav)
	port map (count(7 downto 4), HEX1);
	
   H0: entity work.DisplayDigit(behav)
	port map (count(3 downto 0), HEX0);		
	
end architecture;
	
	
	
