LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity part5 is
	port
	(
			CLOCK_50	 : in std_logic;
			HEX0 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX1 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX2 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX3 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX4 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX5 : OUT STD_LOGIC_VECTOR(0 TO 6);			
			LEDR : OUT STD_LOGIC_VECTOR(2 downto 0)
	);
end;


architecture behav of part5 is
   constant max_count : std_logic_vector(25 downto 0) := (others =>'1');
   signal count1 : std_logic_vector(25 downto 0) := (others =>'0');
	signal count2 : std_logic_vector(2 downto 0) := (others =>'0');
	signal Zero : Boolean;
	SIGNAL M0, M1, M2, M3, M4, M5 : STD_LOGIC_VECTOR(1 DOWNTO 0);
begin

FirstCounter:   
   process (CLOCK_50) is
	begin
		if rising_edge(CLOCK_50) then
		    count1 <= count1 + 1;
	   end if;
   end process;
	
	Zero <= count1 = max_count;
	
SecondCounter:	
   process (CLOCK_50) is
	begin
		if rising_edge(CLOCK_50) then
		    if Zero then
				 if count2 = "101" then
					 count2 <= "000";
				 else
					 count2 <= count2 + 1;
				 end if;
			 end if;	 
	   end if;
   end process;
	
	LEDR <= count2;
	
	U5: entity work.mux_2bit_6to1 
	PORT MAP ( count2, "11", "11", "11", "00", "01", "10", M5);
   H5: entity work.char_7seg PORT MAP (M5, HEX5);
	
	U4: entity work.mux_2bit_6to1 
	PORT MAP ( count2, "11", "11", "00", "01", "10", "11", M4);
   H4: entity work.char_7seg PORT MAP (M4, HEX4);	
	
	U3: entity work.mux_2bit_6to1 
	PORT MAP ( count2, "11", "00", "01", "10", "11", "11", M3);
   H3: entity work.char_7seg PORT MAP (M3, HEX3);
	
	U2: entity work.mux_2bit_6to1 
	PORT MAP ( count2, "00", "01", "10", "11", "11", "11", M2);
   H2: entity work.char_7seg PORT MAP (M2, HEX2);
	
	U1: entity work.mux_2bit_6to1 
	PORT MAP ( count2, "01", "10", "11", "11", "11", "00", M1);
   H1: entity work.char_7seg PORT MAP (M1, HEX1);
	
	U0: entity work.mux_2bit_6to1 
	PORT MAP ( count2, "10", "11", "11", "11", "00", "01", M0);
   H0: entity work.char_7seg PORT MAP (M0, HEX0);
	
	
end architecture;
	
	
	
